// Type definitions for @ckeditor/ckeditor5-table 27.1
// Project: https://ckeditor.com/docs/ckeditor5/latest/api/module_table_table.html
// Definitions by: Federico Panico <https://github.com/fedemp>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// Minimum TypeScript Version: 4.3
import Table from './src/table';
import TableEditing from './src/tableediting';
import TableUI from './src/tableui';
import TableToolbar from './src/tabletoolbar';
import TableCellProperties from './src/tablecellproperties';
import TableCellPropertiesEditing from './src/tablecellproperties/tablecellpropertiesediting';
import TableCellPropertiesUI from './src/tablecellproperties/tablecellpropertiesui';
import TableProperties from './src/tableproperties';
import TablePropertiesEditing from './src/tableproperties/tablepropertiesediting';
import TablePropertiesUI from './src/tableproperties/tablepropertiesui';
import TableClipboard from './src/tableclipboard';
import TableMouse from './src/tablemouse';
import TableKeyboard from './src/tablekeyboard';
import TableSelection from './src/tableselection';
import TableUtils from './src/tableutils';

declare const _default: {
    Table: typeof Table;
    TableEditing: typeof TableEditing;
    TableUI: typeof TableUI;
    TableToolbar: typeof TableToolbar;
    TableCellProperties: typeof TableCellProperties;
    TableCellPropertiesEditing: typeof TableCellPropertiesEditing;
    TableCellPropertiesUI: typeof TableCellPropertiesUI;
    TableProperties: typeof TableProperties;
    TablePropertiesEditing: typeof TablePropertiesEditing;
    TablePropertiesUI: typeof TablePropertiesUI;
    TableMouse: typeof TableMouse;
    TableClipboard: typeof TableClipboard;
    TableKeyboard: typeof TableKeyboard;
    TableSelection: typeof TableSelection;
    TableUtils: typeof TableUtils;
};

export default _default;
